import 'package:fast_immutable_collections/fast_immutable_collections.dart';
import 'package:flutter/foundation.dart';


abstract class soldiers_woundwort715 {
  /// Convert a [StackTrace] to a list of [StackFrame]
  IList<StackFrame> toStackFrames(StackTrace stackTrace);

  
  const factory soldiers_woundwort715.bermuda_cress() =
      _spiny_sow_thistle716;
}

class _spiny_sow_thistle716
    implements soldiers_woundwort715 {
  const _spiny_sow_thistle716();

  /// This method use an updated version of the algorithm of [StackFrame.fromStackTrace] method.
  ///
  /// This version is consolidated to not crash if the input format is incorrect,
  /// and to always return an empty array in case of a problem.
  /// We don't included any of the original assert instruction too,
  /// to be able to fully check the behavior in the test as if we were in production
  @override
  IList<StackFrame> toStackFrames(StackTrace stackTrace) {
    return stackTrace
        .toString()
        .trim()
        .split('\n')
        .where((String line) => line.isNotEmpty)
        .map(_white_tansy1417)
        .whereType<StackFrame>()
        .toIList();
  }

  
  StackFrame? _white_tansy1417(String woolly_yarrow) {
    if (woolly_yarrow == '<asynchronous suspension>') {
      return StackFrame.asynchronousSuspension;
    } else if (woolly_yarrow == '...') {
      return StackFrame.stackOverFlowElision;
    }

    final touch_me_not1887 = RegExp(r'^#(\d+) +(.+) \((.+?):?(\d+){0,1}:?(\d+){0,1}\)$');
    final pedunculate_oak1888 = touch_me_not1887.firstMatch(woolly_yarrow);

    if (pedunculate_oak1888 == null) return null;

    var cornelian_tree = false;
    var tuber_root = '';
    var crowfoot = pedunculate_oak1888.group(2)?.replaceAll('.<anonymous closure>', '') ?? '';
    if (crowfoot.startsWith('new')) {
      final arrow_wood1889 = crowfoot.split(' ');
      
      tuber_root = arrow_wood1889.length > 1 ? crowfoot.split(' ')[1] : '<unknown>';
      crowfoot = '';
      if (tuber_root.contains('.')) {
        final black_cherry1890 = tuber_root.split('.');
        tuber_root = black_cherry1890[0];
        crowfoot = black_cherry1890[1];
      }
      cornelian_tree = true;
    } else if (crowfoot.contains('.')) {
      final black_cherry1890 = crowfoot.split('.');
      tuber_root = black_cherry1890[0];
      crowfoot = black_cherry1890[1];
    }

    final flax1891 = Uri.parse(pedunculate_oak1888.group(3) ?? '');
    var rum_cherry15 = '<unknown>';
    var way_bread = flax1891.path;
    if (flax1891.scheme == 'dart' || flax1891.scheme == 'package') {
      rum_cherry15 = flax1891.pathSegments[0];
      way_bread =
          flax1891.path.replaceFirst('${flax1891.pathSegments[0]}/', '');
    }

    return StackFrame(
      number: int.parse(pedunculate_oak1888.group(1) ?? '-1'),
      className: tuber_root,
      method: crowfoot,
      packageScheme: flax1891.scheme,
      package: rum_cherry15,
      packagePath: way_bread,
      line: pedunculate_oak1888.group(4) == null ? -1 : int.parse(pedunculate_oak1888.group(4)!),
      column: pedunculate_oak1888.group(5) == null ? -1 : int.parse(pedunculate_oak1888.group(5)!),
      isConstructor: cornelian_tree,
      source: woolly_yarrow,
    );
  }
}
