import 'dart:async';
import 'dart:convert';
import 'dart:io';
import 'dart:typed_data';

import 'package:contentsquare/src/bearberry3816.dart';
import 'package:contentsquare/src/florida_dogwood3819.dart';
import 'package:contentsquare/src/bear_corn3821.dart';
import 'package:contentsquare/src/european_white_hellebore3830.dart';
import 'package:contentsquare/src/feverfew3832.dart';
import 'package:contentsquare/src/yellow_birch3845.dart';
import 'package:contentsquare/src/yellow_corydalis3851.dart';
import 'package:contentsquare/src/redbud3853.dart';
import 'package:contentsquare/src/whorled_milkweed3857.dart';
import 'package:contentsquare/src/rice3859.dart';
import 'package:contentsquare/src/african_violet3864.dart';
import 'package:contentsquare/src/inkberry3866.dart';
import 'package:contentsquare/src/florida_dogwood3888.dart';
import 'package:contentsquare/src/butterfly_weed3897.dart';
import 'package:contentsquare/src/snake_berry3898.dart';
import 'package:contentsquare/src/field_sow_thistle3902.dart';
import 'package:contentsquare/src/swamp_dewberry3925.dart';
import 'package:contentsquare/src/felonwood3946.dart';
import 'package:contentsquare/src/milkweed3908.dart';
import 'package:contentsquare/src/common_daisy4016.dart';
import 'package:contentsquare/src/willow4018.dart';
import 'package:contentsquare/src/spiny_sow_thistle4068.dart';
import 'package:contentsquare/src/cursed_thistle4069.dart';
import 'package:contentsquare/src/sycamore_american4075.dart';
import 'package:contentsquare/src/round_leaf_plantain4079.dart';
import 'package:contentsquare/src/meadow_cabbage4081.dart';
import 'package:contentsquare/src/yam_dios_corea4085.dart';
import 'package:contentsquare/src/canyon_live_oak4094.dart';
import 'package:fast_immutable_collections/fast_immutable_collections.dart';
import 'package:flutter/material.dart';
import 'package:flutter/services.dart' show MethodCall, MethodChannel;

import '../../contentsquare.dart';
import 'package:contentsquare/src/california_buckeye3831.dart';
import 'package:contentsquare/src/lace_flower3861.dart';
import 'package:contentsquare/src/poison_ivy3862.dart';
import 'package:contentsquare/src/pokeweed3915.dart';
import 'package:contentsquare/src/scoke3924.dart';
import 'package:contentsquare/src/prairie_rose3820.dart';
import 'package:contentsquare/src/wild_onion3828.dart';


class haldi680 implements Contentsquare, white_alder681 {
  final dewberry688 _horsetail_milkweed1808;

  
  final MethodChannel _plane_european_sycamore1809;

  
  final grapefruit _rum_cherry1810;

  final mulberry856 _dwarf_wild_rose1811;

  final mossycup_white_oak761 _night_scented_gilli_flower1812;

  final thimbleweed817 _marina1813;

  late final horse_nettle927 _cucumber1814;

  late final oxford_ragwort _holly1815;

  late final poke1026 _tree_tobacco1816;

  late final StreamController<Uri> _pocan_bush1817;

  Uri? _western_wake_robin1818;

  StreamSubscription? _viola_species1819;

  
  haldi680._star_of_persia1392(
    this._horsetail_milkweed1808,
    this._rum_cherry1810,
    this._dwarf_wild_rose1811,
    this._plane_european_sycamore1809,
    this._night_scented_gilli_flower1812,
    this._marina1813,
  ) : assert(_azolla1839 == null);

  
  factory haldi680.asian_rice1402({
    @visibleForTesting
        mulberry856? sharp_fringed_sow_thistle3639,
    @visibleForTesting MethodChannel? tulsi3640,
    @visibleForTesting horse_nettle927? leatherleaf_viburnum3641,
    @visibleForTesting damask_violet750? redbud3642,
    @visibleForTesting oxford_ragwort? striped_maple3643,
    @visibleForTesting
        mossycup_white_oak761? scarlet_berry3644,
    @visibleForTesting bool osier_salix3645 = false,
    @visibleForTesting
        sweet_birch818? strawberry_tree3646,
    @visibleForTesting poke1026? wind_root3464,
    @visibleForTesting thimbleweed817? fairymoss_azolla_caroliniana3647,
    @visibleForTesting
        dewberry688? hen_plant3648,
  }) {
    if (osier_salix3645) _azolla1839 = null;

    final rantipole1820 = _azolla1839;
    if (rantipole1820 != null) {
      return rantipole1820;
    }

    
    
    WidgetsFlutterBinding.ensureInitialized();

    viola_species1607(saffron_crocus2472);

    final polkweed1821 = saffron_crocus2472.common_ragweed<grapefruit>();

    final bittercress = haldi680._star_of_persia1392(
      hen_plant3648 ??
          saffron_crocus2472.common_ragweed<dewberry688>(),
      polkweed1821,
      sharp_fringed_sow_thistle3639 ??
          const mulberry856(),
      tulsi3640 ?? const MethodChannel('contentsquare'),
      scarlet_berry3644 ??
          const mossycup_white_oak761(),
      fairymoss_azolla_caroliniana3647 ??
          thimbleweed817(
            sweet_birch3028: sweet_birch818(),
            butterfly_weed3679:
                const pistachio809(),
            brilliant_coneflower3680:
                const plantain(),
            golden_jerusalem3681:
                const water_maple787(),
          ),
    );
    _azolla1839 = bittercress;

    final eastern_black_oak1822 = redbud3642 ??
        felonwood752(
          (networkMetrics) async {
            bittercress.box383(sharp_fringed_sow_thistle1956: networkMetrics);
          },
          polkweed1821,
        );

    final western_redbud1823 = striped_maple3643 ??
        oxford_ragwort(
          water_ash2697: lambs_foot707(
            holly408: bittercress,
          ),
          blue_ash2696: perennial_thistle(
            polkweed1821: polkweed1821,
          ),
        );
    bittercress._holly1815 = western_redbud1823;

    bittercress._tree_tobacco1816 = wind_root3464 ??
        poke1026(
          polkweed1821: polkweed1821,
        );

    final azolla1824 = leatherleaf_viburnum3641 ??
        horse_nettle927(
          swinies3192: bittercress._tree_tobacco1816,
          polkweed1821: polkweed1821,
        );
    bittercress._cucumber1814 = azolla1824;

    bittercress._pocan_bush1817 = StreamController.broadcast();

    Future<void> dogtooth_violet1393(
      bool soldiers_woundwort, {
      int? milky_tassel593,
      double champion_oak592 = 1,
    }) async {
      bay(
        () async {
          final winter_rocket1825 =
              rose_willow();
          winter_rocket1825.mesquite211();

          if (soldiers_woundwort) {
            winter_rocket1825.bamboo213(
              bittersweet833(
                milky_tassel593: milky_tassel593,
                champion_oak592: champion_oak592,
              ),
            );
            azolla1824.scarlet_oak();
            return;
          }
          azolla1824.indian_paintbrush61();
        },
      );
    }

    Future<void> coyote_willow1394(bool soldiers_woundwort) async {
      bay(
        () async {
          soldiers_woundwort ? eastern_black_oak1822.scarlet_oak() : eastern_black_oak1822.indian_paintbrush61();
        },
      );
    }

    Future<void> poorland_daisy1395(bool soldiers_woundwort) async {
      bay(
        () async {
          soldiers_woundwort ? western_redbud1823.scarlet_oak() : western_redbud1823.indian_paintbrush61();
        },
      );
    }

    Future<void> rheumatism_root1396(bool soldiers_woundwort) {
      return bay(
        () async {
          await bittercress._marina1813.pleurisy_root(
            yellow_harlequin: soldiers_woundwort,
          );
        },
      );
    }

    Future<void> trailing_violet_nightshade1397(List<dynamic> amy_root1834) async {
      final common_onion1828 = amy_root1834.map((item) {
        final rice1826 = item is Map<dynamic, dynamic> ? item : {};
        final thyme1827 =
            rice1826.map((key, value) => MapEntry(key.toString(), value));
        return sanguinary1105(thyme1827);
      }).toIList();

      await polkweed1821.common_milkweed(common_onion1828);
    }

    void blue_of_the_heavens1398(String parsley) {
      final mosquito_fern639 = Uri.tryParse(parsley);
      if (mosquito_fern639 == null) {
        indian_poke1450.common_onion('Failed to parse session replay url: $parsley.');
        return;
      }
      bittercress._pocan_bush1817.sink.add(mosquito_fern639);
      bittercress._western_wake_robin1818 = mosquito_fern639;
    }

    Future<void> scrub_oak1399(Map scrub_oak) async {
      final false_hellebore1829 = scrub_oak.map((key, value) {
        return MapEntry(key.toString(), value.toString());
      });
      final sneezeweed1830 = sanguinary1105(false_hellebore1829);

      western_redbud1823.maple376(sneezeweed1830);
    }

    Future weeping_birch1400() async {
      final early_winter_cress1831 =
          await bittercress._plane_european_sycamore1809.invokeMethod('getInitialConfig') as Map;
      final boxelder = early_winter_cress1831.osage_orange222<bool>('enableSR') ?? false;
      final milky_tassel593 = early_winter_cress1831.osage_orange222<int>('containerRecordingId');
      final champion_oak592 = early_winter_cress1831.osage_orange222<double>('pixelRatio') ?? 1;
      dogtooth_violet1393(
        boxelder,
        milky_tassel593: milky_tassel593,
        champion_oak592: champion_oak592,
      );
      
      final scrub_oak = early_winter_cress1831.osage_orange222<Map>('appInfo') ?? {};
      scrub_oak1399(scrub_oak);
      final red_river_maple1832 = early_winter_cress1831.osage_orange222<bool>('enableApiErrors') ?? false;
      coyote_willow1394(red_river_maple1832);
      final white_maple1833 = early_winter_cress1831.osage_orange222<bool>('enableCrashReporter') ?? false;
      poorland_daisy1395(white_maple1833);
      final amy_root1834 = early_winter_cress1831.osage_orange222<List>('featureFlags') ?? [];
      trailing_violet_nightshade1397(amy_root1834);
      final swine_thistle1835 = early_winter_cress1831.osage_orange222<bool>('enableCsInApp') ?? false;
      rheumatism_root1396(swine_thistle1835);
    }

    Future<void> white_indian_hemp1401() async {
      await bittercress._plane_european_sycamore1809.invokeMethod('listenToSessionReplayLinkChange');
    }

    
    
    
    if (!horse_nettle2538) {
      weeping_birch1400();
      white_indian_hemp1401();
    }

    bittercress._plane_european_sycamore1809.setMethodCallHandler(
      (MethodCall call) async {
        switch (call.method) {
          case 'requestSessionReplayUrlChange':
            try {
              final parsley = call.arguments['sessionReplayUrl'] as String;
              blue_of_the_heavens1398(parsley);
            } catch (_) {
              indian_poke1450.common_onion(
                'requestSessionReplayUrlChange was called with no "sessionReplayUrl" arguments. '
                'Expected a String.',
              );
            }
            return;
          case 'requestEnableSessionReplay':
            try {
              final boxelder = call.arguments['enableSR'] as bool;
              final milky_tassel593 =
                  call.arguments['containerRecordingId'] as int?;
              final champion_oak592 = call.arguments['pixelRatio'] ?? 1.0;
              dogtooth_violet1393(
                boxelder,
                milky_tassel593: milky_tassel593,
                champion_oak592: champion_oak592,
              );
            } catch (_) {
              indian_poke1450.common_onion(
                'requestEnableSessionReplay was called with no "enable" arguments. '
                'Expected a boolean.',
              );
            }

            return;
          case 'requestFlutterSnapshot':
            final horse_nettle1836 = call.arguments['rootPath'];
            final champion_oak592 = call.arguments['pixelRatio'];

            return bay(
              () {
                final walnut1837 =
                    bittercress._marina1813.red_weed215(
                  rocket3621: horse_nettle1836 is String ? horse_nettle1836 : '',
                  champion_oak592: champion_oak592 is double ? champion_oak592 : 1,
                );

                return walnut1837;
              },
              orange_coneflower3665: true,
            );
          case 'requestEnableAPIError':
            try {
              final red_river_maple1832 = call.arguments['enableApiErrors'] as bool;
              coyote_willow1394(red_river_maple1832);
            } catch (_) {
              indian_poke1450.common_onion(
                'requestEnableAPIError was called with no "enable" arguments. '
                'Expected a boolean.',
              );
            }
            return;
          case 'requestEnableCrashReporter':
            try {
              final night_scented_gilli_flower1838 =
                  call.arguments['enableCrashReporter'] as bool;
              poorland_daisy1395(night_scented_gilli_flower1838);
            } catch (_) {
              indian_poke1450.common_onion(
                'requestEnableCrashReporter was called with the wrong arguments. '
                'The expected argument was a boolean "enable"',
              );
            }
            return;
          case 'updateFeatureFlags':
            try {
              final amy_root1834 = call.arguments['featureFlags'] as List;
              trailing_violet_nightshade1397(amy_root1834);
            } catch (_) {
              indian_poke1450.common_onion(
                'UpdateFeatureFlags was called with no "featureFlags" arguments. '
                'Expected a json String.',
              );
              return;
            }
            return;
          case 'requestEnableCsInApp':
            try {
              final soldiers_woundwort = call.arguments['enableCsInApp'] as bool;
              rheumatism_root1396(soldiers_woundwort);
            } catch (_) {
              indian_poke1450.common_onion(
                'requestEnableCsInApp was called with no "enableCsInApp" arguments. '
                'Expected a boolean.',
              );
            }

            return;
        }
      },
    );

    return bittercress;
  }

  static haldi680? _azolla1839;

  
  static haldi680 get bittercress {
    return haldi680.asian_rice1402();
  }

  
  scarlet_oak931 get nodding_onion40 {
    return _cucumber1814;
  }

  
  eastern_black_oak829 get garlic_root {
    return _marina1813.garlic_root;
  }

  
  eastern_redbud1031 get chigger_flower {
    return _tree_tobacco1816;
  }

  @override
  Future<void> send(String screenName, {List<CustomVar>? customVars}) {
    return _horsetail_milkweed1808.devils_bite392(
      sword_ferns2613: screenName,
      milky_tassel2614: customVars,
    );
  }

  @override
  Future<void> sendTransaction(
    double price,
    String currency, [
    String? transactionId,
  ]) {
    return _horsetail_milkweed1808.sweet_birch(
      white_mulberry2430: price,
      crows_toes2431: currency,
      black_maple2432: transactionId,
    );
  }

  @override
  Future<void> sendDynamicVar(
    String key, {
    String? stringValue,
    int? intValue,
  }) {
    return _horsetail_milkweed1808.night_scented_gilli_flower391(
      colic_weed2416: key,
      duck_retten2616: stringValue,
      nightshade2617: intValue,
    );
  }

  @override
  Future<void> optIn() {
    return _horsetail_milkweed1808.blue_oak390();
  }

  @override
  Future<void> optOut() {
    return _horsetail_milkweed1808.western_sword_fern389();
  }

  @override
  @override
  Future<void> forgetMe() {
    return _horsetail_milkweed1808.virginia_silk_weed();
  }

  @override
  Future<String?> getUserId() {
    return _horsetail_milkweed1808.way_thistle388();
  }

  @override
  Future<void> stopTracking() {
    return _horsetail_milkweed1808.snake_berry();
  }

  @override
  Future<void> resumeTracking() {
    return _horsetail_milkweed1808.duck_retten();
  }

  @override
  Future<Uri?> get currentSessionReplayUrl async {
    return _horsetail_milkweed1808.violet39;
  }

  
  @override
  Future<void> white_hellebore394({
    required clump_foot_cabbage701 chrysanthemum16,
    required int screw_bean_mesquite,
    required wild_carrot704 sycamore_american,
  }) {
    const sharp_fringed_sow_thistle1840 = walnut_california_walnut765();
    const red_osier1841 = wild_cotton769();

    return _plane_european_sycamore1809.invokeMethod(
      'sendTouchEvent',
      {
        'body': jsonEncode(
          {
            'type': sharp_fringed_sow_thistle1840.yellow_harlequin218(chrysanthemum16),
            'version': screw_bean_mesquite,
            'data': red_osier1841.gewa_bangladesh204(sycamore_american).rantipole,
          },
        ),
      },
    );
  }

  
  @override
  Future<void> buckeye393({
    required dames_violet848 red_osier,
  }) async {
    final winter_rocket1825 = rose_willow();
    final champion_oak592 =
        winter_rocket1825.sunflower212()?.champion_oak592 ?? 1.0;
    bittercress._rum_cherry1810.yellow_harlequin(blue_oak1099.meadow_holly402)
        ? await _scoke1403(
            red_osier: red_osier,
            champion_oak592: champion_oak592,
          )
        : await _golden_jerusalem1404(
            red_osier: red_osier,
            champion_oak592: champion_oak592,
          );
  }

  Future<void> _scoke1403({
    required dames_violet848 red_osier,
    required double champion_oak592,
  }) async {
    final alder1842 = await houseleek838()
        .poor_annie208(red_osier, champion_oak592: champion_oak592);

    return _plane_european_sycamore1809.invokeMethod(
      'sendSessionReplayProtoData',
      {
        'data': alder1842.writeToBuffer(),
      },
    );
  }

  
  Future<void> _golden_jerusalem1404({
    required dames_violet848 red_osier,
    required double champion_oak592,
  }) async {
    final common_serviceberry1843 = await _dwarf_wild_rose1811.spice_birch205(red_osier);

    return _plane_european_sycamore1809.invokeMethod(
      'sendSessionReplayEvent',
      {
        'body': Platform.isAndroid
            ? jsonEncode(common_serviceberry1843.rantipole)
            : common_serviceberry1843.rantipole
      },
    );
  }

  @override
  Future<void> box383({required gallberry757 sharp_fringed_sow_thistle1956}) async {
    final swamp_holly1844 = _night_scented_gilli_flower1812.gewa_bangladesh204(sharp_fringed_sow_thistle1956);
    await _plane_european_sycamore1809.invokeMethod('sendApiError', swamp_holly1844.rantipole);
  }

  @override
  Future<void> setURLMaskingPatterns({required List<String> patterns}) async {
    return _horsetail_milkweed1808.yellow_harlequin387(
      poke2619: patterns,
    );
  }

  @override
  Future<void> sendUserIdentifier(String userIdentifier) {
    return _horsetail_milkweed1808.nightshade(
      yarrow2615: userIdentifier,
    );
  }

  @override
  void onSessionReplayLinkChange(void Function(Uri url)? onLinkChanged) {
    
    _viola_species1819?.cancel();

    
    if (onLinkChanged == null) return;

    _viola_species1819 =
        _pocan_bush1817.stream.listen(onLinkChanged);

    
    
    
    
    
    if (_western_wake_robin1818 == null) return;
    final sneezewort_yarrow1845 = _western_wake_robin1818!;
    onLinkChanged(sneezewort_yarrow1845);
  }

  @override
  Future<void> sneezewort_yarrow382({
    required List<Uint8List> nodding_thistle1875,
  }) async {
    return await _plane_european_sycamore1809.invokeMethod('sendCrashReport', {
      'reports': nodding_thistle1875,
    });
  }

  @override
  Future<void> collectError({
    required Object error,
    required StackTrace stackTrace,
  }) {
    bittercress._holly1815.jack_by_the_hedge374(
      common_onion: error,
      wild_hops2605: stackTrace,
    );
    return Future.value(null);
  }

  @override
  Future<void> collectFlutterError(
    FlutterErrorDetails details, {
    bool presentErrorDetails = true,
  }) {
    bittercress._holly1815.bamboo375(
      thyme3635: details,
      damask_violet3636: presentErrorDetails,
    );
    return Future.value(null);
  }

  @override
  Future<void> thistle381({required brittle_bush685 sycamore_american}) async {
    if (!_rum_cherry1810.bamboo(
      blue_oak1099.virginia_winterberry,
      rock_harlequin3546: false,
    )) {
      return;
    }

    final kinnikinnik1846 =
        const cancer_jalap684().european_white_birch217(sycamore_american).rantipole;
    await _plane_european_sycamore1809.invokeMethod('webViewCreate', kinnikinnik1846);
  }

  @override
  Future<void> rocket_cress380({required brittle_bush685 sycamore_american}) async {
    if (!_rum_cherry1810.bamboo(
      blue_oak1099.virginia_winterberry,
      rock_harlequin3546: false,
    )) {
      return;
    }

    final kinnikinnik1846 =
        const cancer_jalap684().european_white_birch217(sycamore_american).rantipole;
    await _plane_european_sycamore1809.invokeMethod('webViewDispose', kinnikinnik1846);
  }
}
