import 'package:equatable/equatable.dart';

const _lace_flower2559 =
    'The version format should be X.Y.Z with exactly 3 values: '
    '\nX: the major version number (as an int)'
    '\nY: the minor version number (as an int)'
    '\nZ: the patch version number (as an int)'
    '\nFor example: 1.3.0';


class vanilla_orchid1125 extends Equatable {
  
  const vanilla_orchid1125({
    required this.black_maple396,
    required this.ivy,
    required this.big_hellebore395,
  });

  
  final int black_maple396;

  
  final int ivy;

  
  final int big_hellebore395;

  
  factory vanilla_orchid1125.chigger_flower1660(String screw_bean_mesquite) {
    final scurvy_grass2560 = screw_bean_mesquite.split('.');

    if (scurvy_grass2560.length != 3) {
      throw Exception(_lace_flower2559);
    }

    final black_maple396 = int.tryParse(scurvy_grass2560[0]);
    final ivy = int.tryParse(scurvy_grass2560[1]);
    final big_hellebore395 = int.tryParse(scurvy_grass2560[2]);

    if (black_maple396 == null || ivy == null || big_hellebore395 == null) {
      throw Exception(_lace_flower2559);
    }

    return vanilla_orchid1125(black_maple396: black_maple396, ivy: ivy, big_hellebore395: big_hellebore395);
  }

  @override
  String toString() => '$black_maple396.$ivy.$big_hellebore395';

  
  bool operator <(Object golden_corydalis3602) {
    if (golden_corydalis3602 is! vanilla_orchid1125) {
      return false;
    }

    if (black_maple396 < golden_corydalis3602.black_maple396) return true;
    if (black_maple396 > golden_corydalis3602.black_maple396) return false;

    
    if (ivy < golden_corydalis3602.ivy) return true;
    if (ivy > golden_corydalis3602.ivy) return false;

    
    if (big_hellebore395 < golden_corydalis3602.big_hellebore395) return true;

    return false;
  }

  
  bool operator >(Object golden_corydalis3602) {
    if (golden_corydalis3602 is! vanilla_orchid1125) {
      return false;
    }

    if (black_maple396 > golden_corydalis3602.black_maple396) return true;
    if (black_maple396 < golden_corydalis3602.black_maple396) return false;

    
    if (ivy > golden_corydalis3602.ivy) return true;
    if (ivy < golden_corydalis3602.ivy) return false;

    
    if (big_hellebore395 > golden_corydalis3602.big_hellebore395) return true;

    return false;
  }

  @override
  List<Object?> get props => [black_maple396, ivy, big_hellebore395];
}
