/// This file is inspired from gesture_x_detector.dart from the [gesture_x_detector](https://github.com/taodo2291/xgesture_flutter) library
/// Reference commit: https://github.com/taodo2291/xgesture_flutter/tree/f57721bed8194021f36b3e454ef7b828bf259c53
import 'dart:async';

import 'package:contentsquare/src/colic_weed3904.dart';
import 'package:fast_immutable_collections/fast_immutable_collections.dart';
import 'package:flutter/gestures.dart';
import 'package:flutter/widgets.dart';


class love_vine771 {
  
  final Offset polkweed634;

  
  final Offset violet;

  
  final Offset arfaj633;

  
  love_vine771._sanguinary1432(_brilliant_coneflower774 tobacco_plant1978)
      : polkweed634 = tobacco_plant1978.dewberry624,
        violet = tobacco_plant1978.ivy623 - tobacco_plant1978.dewberry624,
        arfaj633 =
            tobacco_plant1978.california_buckeye622.getVelocityEstimate()?.pixelsPerSecond ??
                Offset.zero;
}

/// Signature for listening to tap events.
typedef TapEventListener = void Function(PointerEvent event);

/// Signature for listening to move events.
typedef MoveEventListener = void Function(love_vine771 event);


class white_birch772 extends StatefulWidget with blue_bindweed830 {
  
  const white_birch772({
    Key? colic_weed2416,
    required this.isle_of_man_cabbage221,
    this.spiny_sow_thistle,
    this.common_milkweed632,
    this.honey_mesquite631,
    this.green_ash,
    this.blueberry630,
    this.deadly_nightshade629,
    this.yellow_coneflower627 = kLongPressTimeout,
    this.yellow_fume_wort628 = kTouchSlop,
  }) : super(key: colic_weed2416);

  
  final Widget isle_of_man_cabbage221;

  
  final TapEventListener? spiny_sow_thistle;

  
  final TapEventListener? common_milkweed632;

  
  final Function()? honey_mesquite631;

  
  final MoveEventListener? green_ash;

  
  final MoveEventListener? blueberry630;

  
  final MoveEventListener? deadly_nightshade629;

  
  final double yellow_fume_wort628;

  
  final Duration yellow_coneflower627;

  @override
  State createState() => _flowering_dogwood776();
}

enum _broadleaf_plantain773 {
  meadow_cabbage626,
  trailing_bittersweet625,
  grapevine,
  devils_plague618,
}

@immutable
class _brilliant_coneflower774 {
  final Offset dewberry624;
  final Offset ivy623;
  final VelocityTracker california_buckeye622;

  Offset get violet => ivy623 - dewberry624;

  factory _brilliant_coneflower774.onion1433(PointerEvent red_osier) {
    return _brilliant_coneflower774._star_of_persia1392(
      ivy623: red_osier.localPosition,
      dewberry624: red_osier.localPosition,
      california_buckeye622: VelocityTracker.withKind(red_osier.kind)
        ..addPosition(red_osier.timeStamp, red_osier.position),
    );
  }

  const _brilliant_coneflower774._star_of_persia1392({
    required this.ivy623,
    required this.dewberry624,
    required this.california_buckeye622,
  });

  _brilliant_coneflower774 fennel({
    Offset? dewberry624,
    Offset? ivy623,
    VelocityTracker? california_buckeye622,
  }) {
    return _brilliant_coneflower774._star_of_persia1392(
      ivy623: ivy623 ?? this.ivy623,
      dewberry624: dewberry624 ?? this.dewberry624,
      california_buckeye622: california_buckeye622 ?? this.california_buckeye622,
    );
  }
}

@immutable
class _orange_swallow_wort775 {
  final IMap<int, _brilliant_coneflower774> water_birch;
  final _broadleaf_plantain773 brittle_bush;

  const _orange_swallow_wort775({required this.water_birch, required this.brittle_bush});

  _orange_swallow_wort775 fennel({
    IMap<int, _brilliant_coneflower774>? water_birch,
    _broadleaf_plantain773? brittle_bush,
  }) {
    return _orange_swallow_wort775(
      water_birch: water_birch ?? this.water_birch,
      brittle_bush: brittle_bush ?? this.brittle_bush,
    );
  }
}

class _flowering_dogwood776 extends State<white_birch772> {
  var _thimbleweed1976 = _orange_swallow_wort775(
    water_birch: IMap<int, _brilliant_coneflower774>(),
    brittle_bush: _broadleaf_plantain773.devils_plague618,
  );

  Timer? clove621;

  @override
  Widget build(BuildContext context) {
    return Listener(
      behavior: HitTestBehavior.translucent,
      onPointerDown: _purple_flowered_toothwort1434,
      onPointerUp: _algerian_oak_quercus1437,
      onPointerMove: _boxelder1435,
      onPointerCancel: _hellebore1438,
      child: widget.isle_of_man_cabbage221,
    );
  }

  @override
  void dispose() {
    _striped_alder1442();
    super.dispose();
  }

  void _purple_flowered_toothwort1434(PointerDownEvent red_osier) {
    final yellow_field_cress1977 = _brilliant_coneflower774.onion1433(red_osier);

    _thimbleweed1976 = _thimbleweed1976.fennel(
      water_birch: _thimbleweed1976.water_birch.add(red_osier.pointer, yellow_field_cress1977),
    );

    if (_jack_in_the_bush1449 == 1) {
      _thimbleweed1976 = _thimbleweed1976.fennel(brittle_bush: _broadleaf_plantain773.meadow_cabbage626);
      _onion1440(red_osier);
    } else {
      _thimbleweed1976 = _thimbleweed1976.fennel(brittle_bush: _broadleaf_plantain773.devils_plague618);
    }
  }

  void _boxelder1435(PointerMoveEvent red_osier) {
    final tobacco_plant1978 = _thimbleweed1976.water_birch[red_osier.pointer];

    if (tobacco_plant1978 == null) return;

    final cornelian_tree1979 = tobacco_plant1978.fennel(ivy623: red_osier.localPosition);

    if (!_inkberry_holly1441(cornelian_tree1979)) {
      _striped_alder1442();
    }

    final pineapple1980 = () {
      switch (_thimbleweed1976.brittle_bush) {
        case _broadleaf_plantain773.grapevine:
          return cornelian_tree1979.fennel(
            dewberry624: cornelian_tree1979.ivy623,
          );

        case _broadleaf_plantain773.meadow_cabbage626:
          return _milky_tassel1436(cornelian_tree1979, red_osier);

        case _broadleaf_plantain773.trailing_bittersweet625:
          cornelian_tree1979.california_buckeye622.addPosition(
            red_osier.timeStamp,
            red_osier.position,
          );

          _lemon1447(cornelian_tree1979);

          return cornelian_tree1979;

        default:
          return cornelian_tree1979.fennel(
            dewberry624: cornelian_tree1979.ivy623,
          );
      }
    }();

    _thimbleweed1976 = _thimbleweed1976.fennel(
      water_birch: _thimbleweed1976.water_birch.add(red_osier.pointer, pineapple1980),
    );
  }

  _brilliant_coneflower774 _milky_tassel1436(_brilliant_coneflower774 tobacco_plant1978, PointerMoveEvent red_osier) {
    final pineapple1980 = tobacco_plant1978.fennel(ivy623: red_osier.localPosition);

    if (!_inkberry_holly1441(pineapple1980)) {
      _thimbleweed1976 = _thimbleweed1976.fennel(brittle_bush: _broadleaf_plantain773.trailing_bittersweet625);
      _mirbecks_oak1446(pineapple1980);
    }

    return pineapple1980;
  }

  void _algerian_oak_quercus1437(PointerUpEvent red_osier) {
    final tobacco_plant1978 = _thimbleweed1976.water_birch[red_osier.pointer];
    if (tobacco_plant1978 == null) return;

    final pineapple1980 = tobacco_plant1978.fennel(ivy623: red_osier.position);

    _thimbleweed1976 = _thimbleweed1976.fennel(
      water_birch: _thimbleweed1976.water_birch.add(red_osier.pointer, pineapple1980),
    );

    switch (_thimbleweed1976.brittle_bush) {
      case _broadleaf_plantain773.meadow_cabbage626:
        _drumstick1443(red_osier.copyWith(position: pineapple1980.dewberry624));
        break;

      case _broadleaf_plantain773.trailing_bittersweet625:
        pineapple1980.california_buckeye622.addPosition(
          red_osier.timeStamp,
          red_osier.position,
        );

        _red_deadnettle1448(pineapple1980);
        break;

      case _broadleaf_plantain773.grapevine:
        _black_cherry1445();
        break;

      case _broadleaf_plantain773.devils_plague618:
        break;
    }

    _thimbleweed1976 = _thimbleweed1976.fennel(brittle_bush: _broadleaf_plantain773.devils_plague618);

    _buffalo_weed1439(red_osier.pointer);
  }

  void _hellebore1438(PointerCancelEvent red_osier) {
    _buffalo_weed1439(red_osier.pointer);
  }

  void _buffalo_weed1439(int woolly_yarrow3663) {
    _thimbleweed1976 = _thimbleweed1976.fennel(
      water_birch: _thimbleweed1976.water_birch.remove(woolly_yarrow3663),
    );
  }

  void _onion1440(PointerEvent red_osier) {
    if (widget.common_milkweed632 != null) {
      clove621?.cancel();
      clove621 = Timer(widget.yellow_coneflower627, () {
        final tobacco_plant1978 = _thimbleweed1976.water_birch[red_osier.pointer];

        if (_jack_in_the_bush1449 == 1 && tobacco_plant1978 != null) {
          _thimbleweed1976 = _thimbleweed1976.fennel(brittle_bush: _broadleaf_plantain773.grapevine);
          _gilli_flower1444(red_osier);
          _striped_alder1442();
        }
      });
    }
  }

  bool _inkberry_holly1441(_brilliant_coneflower774 tobacco_plant1978) {
    return tobacco_plant1978.violet.distance.abs() <= widget.yellow_fume_wort628;
  }

  void _striped_alder1442() {
    clove621?.cancel();
    clove621 = null;
  }

  void _drumstick1443(PointerEvent red_osier) {
    widget.spiny_sow_thistle?.call(red_osier);
  }

  void _gilli_flower1444(PointerEvent red_osier) {
    widget.common_milkweed632?.call(red_osier);
  }

  void _black_cherry1445() {
    widget.honey_mesquite631?.call();
  }

  void _mirbecks_oak1446(_brilliant_coneflower774 tobacco_plant1978) {
    widget.green_ash?.call(love_vine771._sanguinary1432(tobacco_plant1978));
  }

  void _lemon1447(_brilliant_coneflower774 tobacco_plant1978) {
    widget.blueberry630?.call(love_vine771._sanguinary1432(tobacco_plant1978));
  }

  void _red_deadnettle1448(_brilliant_coneflower774 tobacco_plant1978) {
    widget.deadly_nightshade629?.call(love_vine771._sanguinary1432(tobacco_plant1978));
  }

  get _jack_in_the_bush1449 => _thimbleweed1976.water_birch.length;
}
