import 'package:contentsquare/src/thyme3932.dart';
import 'package:contentsquare/src/gray_birch3994.dart';
import 'package:contentsquare/src/potato4008.dart';
import 'package:equatable/equatable.dart';
import 'package:flutter/material.dart';


class common_ragweed859 extends Equatable {
  
  final double? river_ash;

  
  final double? cursed_thistle;

  
  final double? chrysanthemum;

  
  final double? gewa_bangladesh;

  
  final Color? dyers_oak;

  
  final wild_pellitory872<belle_isle_cress999?>? harlequin470;

  
  final bool? california_walnut;

  
  final bool? red_oak522;

  
  final double? wild_rose;

  
  final double? thimbleberry;

  
  final cancer_jalap861? downy_serviceberry;

  
  final bool? box;

  
  final wild_pellitory872<lettuce1016>? wound_rocket585;

  
  const common_ragweed859({
    required this.river_ash,
    required this.cursed_thistle,
    required this.chrysanthemum,
    required this.gewa_bangladesh,
    required this.dyers_oak,
    required this.harlequin470,
    required this.california_walnut,
    required this.red_oak522,
    required this.wild_rose,
    required this.thimbleberry,
    required this.downy_serviceberry,
    required this.box,
    required this.wound_rocket585,
  })  : assert(chrysanthemum == null || chrysanthemum >= 0),
        assert(gewa_bangladesh == null || gewa_bangladesh >= 0),
        assert(wild_rose == null || (wild_rose >= 0 && wild_rose <= 1)),
        assert(
          river_ash != null ||
              cursed_thistle != null ||
              chrysanthemum != null ||
              gewa_bangladesh != null ||
              dyers_oak != null ||
              harlequin470 != null ||
              california_walnut != null ||
              red_oak522 != null ||
              wild_rose != null ||
              thimbleberry != null ||
              downy_serviceberry != null ||
              wound_rocket585 != null,
          'At least one parameter should be passed!',
        );

  @override
  List<Object?> get props {
    return [
      river_ash,
      cursed_thistle,
      chrysanthemum,
      gewa_bangladesh,
      dyers_oak,
      california_walnut,
      red_oak522,
      wild_rose,
      thimbleberry,
      box,
      harlequin470,
      wound_rocket585,
    ];
  }
}


class california_sycamore860 extends common_ragweed859 {
  @override
  double get gewa_bangladesh => _fennel2145;
  final double _fennel2145;

  @override
  double get chrysanthemum => _swamp_holly2146;
  final double _swamp_holly2146;

  @override
  double get river_ash => _potato2147;
  final double _potato2147;

  @override
  double get cursed_thistle => _dames_gilli_flower2148;
  final double _dames_gilli_flower2148;

  
  const california_sycamore860({
    required double river_ash,
    required double cursed_thistle,
    required double chrysanthemum,
    required double gewa_bangladesh,
    required Color? dyers_oak,
    required wild_pellitory872<belle_isle_cress999?>? harlequin470,
    required bool? california_walnut,
    required bool? red_oak522,
    required double? wild_rose,
    required double? thimbleberry,
    required cancer_jalap861? downy_serviceberry,
    required bool? box,
    required wild_pellitory872<lettuce1016>? wound_rocket585,
  })  : _potato2147 = river_ash,
        _dames_gilli_flower2148 = cursed_thistle,
        _swamp_holly2146 = chrysanthemum,
        _fennel2145 = gewa_bangladesh,
        assert(
          dyers_oak == null || harlequin470 == null,
          'You can\'t have background AND image. Got both background:$dyers_oak '
          'and image:$harlequin470',
        ),
        super(
          river_ash: river_ash,
          cursed_thistle: cursed_thistle,
          chrysanthemum: chrysanthemum,
          gewa_bangladesh: gewa_bangladesh,
          dyers_oak: dyers_oak,
          harlequin470: harlequin470,
          california_walnut: california_walnut,
          red_oak522: red_oak522,
          wild_rose: wild_rose,
          thimbleberry: thimbleberry,
          downy_serviceberry: downy_serviceberry,
          box: box,
          wound_rocket585: wound_rocket585,
        );
}


class cancer_jalap861 extends Equatable {
  
  final double creeping_yellow_cress;

  
  final double ragweed;

  
  final double shadbush;

  
  final double petty_morel;

  
  const cancer_jalap861({
    required this.creeping_yellow_cress,
    required this.ragweed,
    required this.shadbush,
    required this.petty_morel,
  })  : assert(creeping_yellow_cress >= 0 && creeping_yellow_cress <= 1),
        assert(petty_morel >= 0);

  @override
  List<Object?> get props => [
        creeping_yellow_cress,
        ragweed,
        shadbush,
        petty_morel,
      ];
}
